OUTPUT_FORMAT("elf32-ae32000-little", "elf32-ae32000-big",
              "elf32-ae32000-little")
OUTPUT_ARCH(ae32000)
ENTRY(_Reset_Start)
/*GROUP(-lc -lgcc -lm )*/
/*SEARCH_DIR(.);*/

MEMORY
{
    rom (rx)	: ORIGIN = 0x00000000,	LENGTH = 8M
/* vector table will stored at 0x20000000 by InitInterrupt()*/
        dspm(rwx)	: ORIGIN = 0x20000200,	LENGTH = (8*1024-0x200)
        ispm(rwx)	: ORIGIN = 0x20002000,	LENGTH = 8K
        ram (!rx)	: ORIGIN = 0xC1000000,	LENGTH = 16M
        nocache (!rx): ORIGIN = 0xC2800000,	LENGTH = 1M
    }

SECTIONS
{
	.text :
    {
        *(.vects)
        *(.text)
        . = ALIGN(4);
        *(.stub)
        *(.rodata)
        *(.rodata.str1.*)
        *(.rodata1)
        ___ctors = . ;
        *(.ctors)
        ___ctors_end = . ;
        ___dtors = . ;
        *(.dtors)
        ___dtors_end = . ;
        *(.gnu.linkonce.*)
        *(.gcc_except_table)
    } > rom
    _etext = . ;
    PROVIDE (etext = .);

	.data :
    AT ( (LOADADDR (.text) + SIZEOF(.text) + 3) & ~ (4 - 1))
    {
        . = ALIGN(4);
        __ram_data_start = . ;
        *(.data)
        *(.sdata)
        /*CONSTRUCTORS*/
        . = ALIGN(4);
        __ram_data_end = .;
    } > ram
    __rom_data_start  =  LOADADDR (.data);

    .bss ALIGN(0x4) : AT ((LOADADDR (.data) + SIZEOF(.data) + 3) & ~ (4 - 1) )
    {
        . = ALIGN(4);
        __bss_start = .;
        *(.dynbss)
        *(.bss)
        *(COMMON)
        . = ALIGN(4);
        __bss_end = .;
    } > ram

    _end = . ;
    PROVIDE (end = .);
	.dspm : AT ( (LOADADDR (.data) + SIZEOF(.data) + 3) & ~ (4 - 1))
    {
        . = ALIGN(4);
        __ram_dspm_start = . ;
        *(.spm)
        . = ALIGN(4);
        __ram_dspm_end = .;
    } > dspm
    __rom_dspm_start  =  LOADADDR (.dspm);
	.ispm : AT ( (LOADADDR (.dspm) + SIZEOF(.dspm) + 3) & ~ (4 - 1))
    {
        . = ALIGN(4);
        __ram_ispm_start = . ;
        *(.ispm)
        . = ALIGN(4);
        __ram_ispm_end = .;
    } > ispm
    __rom_ispm_start  =  LOADADDR (.ispm);

	.nocache : AT (LOADADDR (.ispm) + SIZEOF(.ispm) )
    {
        . = ALIGN(4);
        __ram_nocache_start = . ;
        *(.nocache_data)
        . = ALIGN(4);
        __ram_nocache_end = .;
    } > nocache
    __rom_nocache_start  =  LOADADDR (.nocache);
	
	._stack 0xC1FFFFFC :
    {
        _stack = .;
        *(._stack)
    }
}
PROVIDE(___data_size = SIZEOF(.data));
PROVIDE(___bss_size = SIZEOF(.bss));


